#!/bin/bash

#
# Shell script to create a zip-file containing a complete release.
# It's written for my system (Linux) but should work without too
# much effort on any Unix-ish OS.
#

VERSION=1.0
PKG=MiniWeb

mkdir $PKG

mkdir $PKG/sixx
cp		./sixx/SIXX-Core.st \
		./sixx/SIXX-ParserAdapter.st \
		./sixx/SIXX-InOut-Squeak.cs \
		./sixx/SIXX-Squeak.st \
		./sixx/SIXX-Test.st \
		./sixx/SIXX-InOut.cs \
		./sixx/SIXX-Examples.st \
		./sixx/sixx-license.html \
		\
		$PKG/sixx


mkdir $PKG/yaxo
cp		./yaxo/Yaxo-2.0b.st $PKG/yaxo


mkdir $PKG/Seaside2-avi.31
cp		./Seaside2-avi.31/seaside.st $PKG/Seaside2-avi.31/


mkdir $PKG/shrink
cp		./shrink/TwoStageShrink.cs \
		./shrink/MiniNet.cs \
		./shrink/Shrinking.htm \
		\
		$PKG/shrink
		

mkdir $PKG/kom-5.1.1 
cp		./kom-5.1.1/Kom.st \
		./kom-5.1.1/Kom-preload.cs \
		\
		$PKG/kom-5.1.1

for i in go.doit mkzip.sh README; do
	qscat $i > $PKG/$i
done

#cp  ./go.doit ./mkzip.sh README $PKG



zip -9r $PKG-$VERSION.zip $PKG

rm -rf $PKG

