TestCase subclass: #SixxAbstractTestCase
	instanceVariableNames: 'originalUseEnvironment '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxAbstractTestCase methodsFor: 'running' stamp: 'MU 3/6/2003 15:49'!
setUp
	originalUseEnvironment := SixxSetting useEnvironment.
	SixxSetting useEnvironment: false! !

!SixxAbstractTestCase methodsFor: 'running' stamp: 'MU 3/6/2003 15:49'!
tearDown
	SixxSetting useEnvironment: originalUseEnvironment! !


SixxAbstractTestCase subclass: #SixxConstantsTestCase
	instanceVariableNames: 'oldSixxConstants '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxConstantsTestCase methodsFor: 'running' stamp: 'kuri-t 5/21/2002 19:14'!
setUp
	^ self oldSixxConstants: SixxConstants! !

!SixxConstantsTestCase methodsFor: 'running' stamp: 'kuri-t 5/21/2002 19:22'!
tearDown
	SixxConstants initialize.
	SixxConstants xmlVersion: self oldSixxConstants xmlVersion.
	SixxConstants xmlEncoding: self oldSixxConstants xmlEncoding.
	SixxConstants sixxVersion: self oldSixxConstants sixxVersion! !


!SixxConstantsTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 13:56'!
testInitialize
	SixxConstants initialize.
	self
		should: [SixxConstants xmlVersion = '1.0'].
	self
		should: [SixxConstants xmlEncoding = 'utf-8'].
	self
		should: [SixxConstants sixxVersion = '1.0']! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 13:59'!
testSixxStartTag
	SixxConstants initialize.
	self
		should: [SixxConstants sixxStartTag = '<sixx sixx.version="1.0">'].
	SixxConstants sixxVersion: '2.0'.
	self
		should: [SixxConstants sixxStartTag = '<sixx sixx.version="2.0">']! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:00'!
testXmlDeclaration
	SixxConstants initialize.
	self
		should: [SixxConstants xmlDeclaration = '<?xml version="1.0" encoding="utf-8"?>'].
	SixxConstants xmlVersion: '3.0'.
	SixxConstants xmlEncoding: 'sjis'.
	self
		should: [SixxConstants xmlDeclaration = '<?xml version="3.0" encoding="sjis"?>']! !


!SixxConstantsTestCase methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 19:12'!
oldSixxConstants
	^ oldSixxConstants! !

!SixxConstantsTestCase methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 19:13'!
oldSixxConstants: aSixxConstants
	oldSixxConstants := aSixxConstants! !


SixxAbstractTestCase subclass: #SixxGeneratingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:01'!
testSixxStringForArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Array new: 3.
	arr at: 1 put: 10.
	arr at: 2 put: 20.
	arr at: 3 put: 30.
	self
		should: [arr sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:01'!
testSixxStringForBag
	| bag result |
	bag := Bag new.
	bag add: 10.
	bag add: 20.
	bag add: 30.
	result := Object readSixxFrom: bag sixxString.
	self
		should: [result size = 3].
	self
		should: [result includes: 10].
	self
		should: [result includes: 20].
	self
		should: [result includes: 30]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:01'!
testSixxStringForBoolean
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self
		should: [true sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 6/29/2002 15:51'!
testSixxStringForByteArray
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="ByteArray" >#( 10 20 30 )</sixx.object>
'.
	self
		should: [(ByteArray with: 10 with: 20 with: 30) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:02'!
testSixxStringForCharacter
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self
		should: [$A sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:05'!
testSixxStringForClass
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="String" >value1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="String" >value2</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="String" >value3</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 'value1'.
	SixxMockClassForUnitTest instVar2: 'value2'.
	SixxMockClassForUnitTest instVar3: 'value3'.
	self
		should: [SixxMockClassForUnitTest sixxString = expectedStr]
! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:06'!
testSixxStringForColor
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [Color blue sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/3/2002 01:15'!
testSixxStringForCompositeDictionary
	| dic childDic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >parent1</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >sample string.</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >parent4</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="Dictionary" >
			<sixx.object sixx.id="7" sixx.type="Association" >
				<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >child1</sixx.object>
				<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >abcde</sixx.object>
			</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="10" sixx.type="Association" >
		<sixx.object sixx.id="11" sixx.name="key" sixx.type="Symbol" >parent3</sixx.object>
		<sixx.object sixx.id="12" sixx.name="value" sixx.type="Array" >
			<sixx.object sixx.id="13" sixx.type="SmallInteger" >10</sixx.object>
			<sixx.object sixx.id="14" sixx.type="SmallInteger" >20</sixx.object>
			<sixx.object sixx.id="15" sixx.type="SmallInteger" >30</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="16" sixx.type="Association" >
		<sixx.object sixx.id="17" sixx.name="key" sixx.type="Symbol" >parent2</sixx.object>
		<sixx.object sixx.id="18" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
</sixx.object>
'.
	childDic := Dictionary new.
	childDic at: #child1 put: 'abcde'.
	dic := Dictionary new.
	dic at: #parent1 put: 'sample string.'.
	dic at: #parent2 put: 100.
	dic at: #parent3 put: #(10 20 30 ).
	dic at: #parent4 put: childDic.
	self
		should: [(Object readSixxFrom: dic sixxString) = (Object readSixxFrom: expected)]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:14'!
testSixxStringForDate
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self
		should: [(Date
				newDay: 14
				month: 5
				year: 2002) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/3/2002 01:13'!
testSixxStringForDictionary
	| dic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >value2</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >value3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Dictionary new.
	dic at: #key1 put: 'value1'.
	dic at: #key2 put: 'value2'.
	dic at: #key3 put: 'value3'.
	self
		should: [(Object readSixxFrom: dic sixxString) = (Object readSixxFrom: expected)]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'minami 3/18/2003 01:36'!
testSixxStringForInterval
	| interval expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	interval := 1 to: 10 by: 3.
	self should: [interval sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:18'!
testSixxStringForNumber
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self
		should: [(3 / 4) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:18'!
testSixxStringForOrdredCollection
	| expectedStr col |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="OrderedCollection" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	col := OrderedCollection new.
	col add: 10.
	col add: 20.
	col add: 30.
	self
		should: [col sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/22/2002 00:08'!
testSixxStringForRunArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.

	arr := RunArray runs: #(1 2 1) values: #(1 2 3).
	self should: [arr sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:19'!
testSixxStringForSimpleObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Object" >
</sixx.object>
'.
	self
		should: [Object new sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:20'!
testSixxStringForString
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" >Hi&#44; I&apos;m String-object</sixx.object>
'.
	self
		should: ['Hi, I''m String-object' sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 9/2/2002 02:37'!
testSixxStringForStringUsingCDATA
	| originalSetting expectedStr |
	[originalSetting := SixxSetting useCDATA.
	SixxSetting useCDATA: true.
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	self
		should: ['Hi, I''m String-object.
How are you?
' sixxString = expectedStr]]
		ensure: [SixxSetting useCDATA: originalSetting]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 6/11/2003 17:44'!
testSixxStringForTime
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Time" >' 
				, (Time readFrom: '1:30:59 pm' readStream) sixxContentString , '</sixx.object>
'.
	self 
		should: [(Time readFrom: '1:30:59 pm' readStream) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:22'!
testSixxStringForUndefinedObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self
		should: [nil sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:33'!
testSixxStringForVariableObject
	| expectedStr variableObj |
	expectedStr :='<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.id="6" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	
	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3).
	self
		should: [variableObj sixxString = expectedStr].
	
	! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:34'!
testSixxStringForVariableObjectNoData
	| expectedStr variableObj |
	
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.

	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #().
	self
		should: [variableObj sixxString = expectedStr].
! !


SixxAbstractTestCase subclass: #SixxLoadingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:23'!
testReadSixxForArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				= 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:23'!
testReadSixxForBag
	| sixxString bag |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Bag" >
	<sixx.object sixx.id="1" sixx.type="String" >abcd</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.idref="2" ></sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
</sixx.object>
'.
	bag := Object readSixxFrom: sixxString.
	self
		should: [bag size = 4].
	self
		should: [(bag occurrencesOf: 10)
				= 2].
	self
		should: [(bag occurrencesOf: 'abcd')
				= 1].
	self
		should: [(bag occurrencesOf: #(10 20 ))
				= 1]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:25'!
testReadSixxForBoolean
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= true]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:25'!
testReadSixxForByteArray
	| sixxString byteArr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="ByteArray" >#( 10 20 30 )</sixx.object>
'.
	byteArr := Object readSixxFrom: sixxString.
	self
		should: [byteArr size = 3].
	self
		should: [(byteArr at: 1)
				= 10].
	self
		should: [(byteArr at: 2)
				= 20].
	self
		should: [(byteArr at: 3)
				= 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:29'!
testReadSixxForCharacter
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= $A]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:31'!
testReadSixxForClass
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 0;
		 instVar2: 0;
		 instVar3: 0.
	self
		should: [SixxMockClassForUnitTest instVar1 = 0].
	self
		should: [SixxMockClassForUnitTest instVar2 = 0].
	self
		should: [SixxMockClassForUnitTest instVar3 = 0].
	Object readSixxFrom: sixxString.
	self
		should: [SixxMockClassForUnitTest instVar1 = 10].
	self
		should: [SixxMockClassForUnitTest instVar2 = 20].
	self
		should: [SixxMockClassForUnitTest instVar3 = 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:32'!
testReadSixxForColor
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= Color blue]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:33'!
testReadSixxForCompositeObject
	| sixxString slipObj headerObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockEnvelope" >
	<sixx.object sixx.id="1" sixx.name="header" sixx.type="SixxMockHeader" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >99</sixx.object>
	</sixx.object>
</sixx.object>
'.
	slipObj := Object readSixxFrom: sixxString.
	headerObj := slipObj header.
	self
		should: [headerObj id = '99']! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 5/26/2003 11:17'!
testReadSixxForCorruptRecursiveDictionary
	| originalRecoveryRead |
	[ |  sixxString |
	originalRecoveryRead := SixxSetting useRecoveryRead.
	SixxSetting useRecoveryRead: false.
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.
	self should:[ Object readSixxFrom: sixxString] raise: SixxXmlParseError.
	
	] ensure: [SixxSetting useRecoveryRead: originalRecoveryRead]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:34'!
testReadSixxForDate
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (Date
						newDay: 14
						month: 5
						year: 2002)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:35'!
testReadSixxForDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 2].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'minami 3/18/2003 01:36'!
testReadSixxForInterval
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1 to: 10 by: 3)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:37'!
testReadSixxForRecursiveArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				== arr]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:38'!
testReadSixxForRecursiveDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.idref="0" sixx.name="value" ></sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 3].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100].
	self
		should: [(dic at: #key3)
				== dic]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 7/22/2002 00:06'!
testReadSixxForRunArray
	| sixxString runArray |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	runArray := Object readSixxFrom: sixxString.

	self should: [runArray runs = #(1 2 1)].
	self should: [runArray values = #(1 2 3)]
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:39'!
testReadSixxForSimpleObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockHeader" >
	<sixx.object sixx.id="1" sixx.name="id" sixx.type="String" >1000</sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString) id = '1000']! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 9/2/2002 02:43'!
testReadSixxForStringUsingCDATA
	| originalSetting sixxString string |
	[originalSetting := SixxSetting useCDATA.
	SixxSetting useCDATA: true.
	sixxString := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	string := Object readSixxFrom: sixxString.
	self
		should: [string = 'Hi, I''m String-object.
How are you?
']]
		ensure: [SixxSetting useCDATA: originalSetting]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:39'!
testReadSixxForTime
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Time" >4:10:32 pm</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (Time
						readFrom: (ReadStream on: '4:10:32 pm'))]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:43'!
testReadSixxForUndefinedObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= nil]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 10/21/2002 01:09'!
testReadSixxForVariableObject
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.id="6" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 3].
	self should: [ (variableObj at: 1) = 1].
	self should: [ (variableObj at: 2) = 2].
	self should: [ (variableObj at: 3) = 3].
	
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:32'!
testReadSixxForVariableObjectNoData
	
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 0].

	
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:43'!
testReadSixxWithClassDoesNotExist
	| str catched |
	str := '<sixx.object sixx.id="0" sixx.type="doesNotExistString" >abcde</sixx.object>
'.
	self
		should: [(Object readSixxFrom: str)
				= nil].
	catched := false.
	self
		should: [[Object readSixxFrom: str]
				on: SixxClassNotFound
				do: [:ex | catched := true].
			catched]! !


Object variableSubclass: #SixxMockBinaryData
	instanceVariableNames: 'author version '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:58'!
author
	^author! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:59'!
author: aString
	author :=  aString
! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:59'!
version
	^version! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 23:00'!
version: aString
	version :=  aString
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxMockBinaryData class
	instanceVariableNames: ''!

!SixxMockBinaryData class methodsFor: 'instance creation' stamp: 'MU 10/21/2002 01:03'!
author: author version: version data: binaryData
	"SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3)"
	| inst idx |
	inst := self new: binaryData size.
	idx := 0.
	binaryData do: [:each | inst at: (idx := idx + 1) put: each].
	inst author: author.
	inst version: version.
	^inst

! !


Object subclass: #SixxMockEnvelope
	instanceVariableNames: 'header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockEnvelope methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
header
	^ header! !

!SixxMockEnvelope methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
header: aHeader
	header := aHeader! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxMockEnvelope class
	instanceVariableNames: ''!

!SixxMockEnvelope class methodsFor: 'instance creation' stamp: 'mu 5/10/2002 17:48'!
header: aHeader
	super initialize.
	^ self new header: aHeader! !


Object subclass: #SixxMockHeader
	instanceVariableNames: 'id '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockHeader methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
id
	^ id! !

!SixxMockHeader methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
id: aString
	id := aString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxMockHeader class
	instanceVariableNames: ''!

!SixxMockHeader class methodsFor: 'instance creation' stamp: 'mu 5/10/2002 17:48'!
id: aString
	^ self new id: aString! !


Object subclass: #SixxMockSuperClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxMockSuperClassForUnitTest class
	instanceVariableNames: 'instVar1 instVar2 '!

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'kuri-t 6/10/2002 14:44'!
instVar1
	instVar1 isNil
		ifTrue: [instVar1 := ''].
	^ instVar1! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:47'!
instVar1: aString
	instVar1 := aString! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'kuri-t 6/10/2002 14:44'!
instVar2
	instVar2 isNil
		ifTrue: [instVar2 := ''].
	^ instVar2! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:47'!
instVar2: aString
	instVar2 := aString! !


!SixxMockSuperClassForUnitTest class methodsFor: 'class initialization' stamp: 'mu 5/10/2002 17:47'!
initialize
	"MockSuperClassForUnitTest initialize"
	super initialize.
	instVar1 := nil.
	instVar2 := nil.! !


SixxMockSuperClassForUnitTest subclass: #SixxMockClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxMockClassForUnitTest class
	instanceVariableNames: 'instVar3 '!

!SixxMockClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
instVar3
	instVar3 isNil ifTrue: [instVar3 := ''].
	^instVar3! !

!SixxMockClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
instVar3: aString
	instVar3 := aString! !


!SixxMockClassForUnitTest class methodsFor: 'class initialization' stamp: 'mu 5/10/2002 17:48'!
initialize
	"MockClassForUnitTest initialize"
	super initialize.
	instVar3 := nil.! !


SixxAbstractTestCase subclass: #SixxNamespaceSupportTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxNamespaceSupportTestCase methodsFor: 'running' stamp: 'MU 3/25/2003 02:35'!
setUp
	originalUseEnvironment := SixxSetting useEnvironment.
	SixxSetting useEnvironment: true! !

!SixxNamespaceSupportTestCase methodsFor: 'running' stamp: 'MU 3/25/2003 02:35'!
tearDown
	SixxSetting useEnvironment: originalUseEnvironment! !


!SixxNamespaceSupportTestCase methodsFor: 'tests' stamp: 'MU 3/25/2003 02:36'!
testNamespacedArray
	"self debug: #testNamespacedArray"
	| arraySixx1 array1  arraySixx2 array2  |
	arraySixx1 :=  '<sixx.object sixx.id="0" sixx.type="Array" sixx.env="Core" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" sixx.env="Core" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" sixx.env="Core" >20</sixx.object>
</sixx.object>
'.
	array1 := Object readSixxFrom: arraySixx1.
	self should: [array1 = #(10 20)].
	
	arraySixx2 := array1 sixxString. 
	array2 := Object readSixxFrom: arraySixx2.
	self should: [array2 = #(10 20)]! !


SixxAbstractTestCase subclass: #SixxReadStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testAtEnd
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'
				and: [stream atEnd not]].
	self
		should: [stream next = 'b'
				and: [stream atEnd not]].
	self
		should: [stream next = 'c'
				and: [stream atEnd]].
	self
		should: [stream next = nil
				and: [stream atEnd]]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testCachedObjects
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	stream next; next.
	self
		should: [(stream cachedObjects at: 1)
				= 'a'].
	self
		should: [(stream cachedObjects at: 2)
				= 'b'].
	self
		shouldnt: [stream cachedObjects includesKey: 3].
	stream next.
	self
		should: [(stream cachedObjects at: 3)
				= 'c']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testNext
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'].
	self
		should: [stream next = 'b'].
	self
		should: [stream next = 'c'].
	self
		should: [stream next = nil]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:47'!
testNextMany
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [(stream next: 2)
				= (OrderedCollection with: 'a' with: 'b')].
	stream reset.
	self
		should: [(stream next: 5)
				= (OrderedCollection
						with: 'a'
						with: 'b'
						with: 'c')]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:48'!
testNextWithIdred
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$u</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
	<sixx.object sixx.idref="1" ></sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = $a].
	self
		should: [stream next = $u].
	self
		should: [stream next = $a].
	self
		should: [stream next = $u]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:48'!
testPeek
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream position = 0].
	self
		should: [stream peek = 'a'].
	self
		should: [stream position = 0].
	self
		should: [stream next = 'a']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:49'!
testPosition
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	stream next: 3.
	self
		should: [stream position = 3].
	stream position: 1.
	self
		should: [stream next = 'b']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'MU 2/28/2003 23:35'!
testReadEmptyStream
	| stream empStream |
	empStream := '' readStream.
	self
		should: [empStream size = 0].
	stream :=  SixxReadStream on: empStream.
	
	self
		should: [stream position = 0].
	self
		should: [stream atEnd].
	self
		should: [stream next isNil].
	! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 16:34'!
testReadNextContainsIdref
	| str stream firstObj secondObj thirdObj |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream size = 3].
	firstObj := stream next.
	secondObj := stream next.
	thirdObj := stream next.
	self
		should: [firstObj = #(10 20 30 )].
	self
		should: [(secondObj at: 1)
				== firstObj].
	self
		should: [thirdObj = #(10 20 30 )
				and: [thirdObj ~~ firstObj]]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'MU 5/26/2003 11:36'!
testRecoveryRead
	| originalRecoveryRead   |
	[ |  str stream nextObject |
	originalRecoveryRead := SixxSetting useRecoveryRead.
	SixxSetting useRecoveryRead: true.
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.
	stream := SixxReadStream on: str readStream.
	self shouldnt: [nextObject := stream next] raise: SixxXmlParseError.
	self
		should: [nextObject class = Dictionary].
	self
		should: [(nextObject at: #key1)
				= 'value1'].
	self
		should: [(nextObject at: #key2)
				= 100].
	self
		shouldnt: [(nextObject includesKey: #key3)].
	
	] ensure: [SixxSetting useRecoveryRead: originalRecoveryRead]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testReset
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	[stream atEnd]
		whileFalse: [stream next].
	self
		should: [stream next = nil].
	stream reset.
	self
		should: [stream position = 0]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testSize
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream size = 3]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testSkip
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream position = 0].
	stream skip: 1.
	self
		should: [stream position = 1].
	stream next.
	self
		should: [stream position = 2].
	stream skip: 1.
	self
		should: [stream position = 3].
	stream skip: -1.
	self
		should: [stream position = 2].
	stream skip: 2.
	self
		should: [stream position = 3]! !


SixxAbstractTestCase subclass: #SixxWriteStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testCloseTwice
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testKeepStreamOpening
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNeverNextPutAndThenClose
	| st wst expected |
	expected := ''.
	st := WriteStream on: String new.
	wst := SixxWriteStream on: st.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNextPut
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNextPutAll
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="Character" >$c</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPutAll: 'abc'.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:38'!
testWriteRecursiveObject
	| st wst expected arr col |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	arr := #(10 20 30 ).
	col := OrderedCollection with: arr.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: arr.
	wst nextPut: col.
	wst nextPut: #(10 20 30 ) copy.
	wst close.
	self
		should: [st contents = expected]! !


SixxAbstractTestCase subclass: #SixxXmlParserTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxXmlParserTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:59'!
testParseXmlWithSixxVwXmlParserAdapter
	| sixxString result oldParser |
	self class environment
		at: #VWXMLXMLParser
		ifAbsent: [^ self].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	[SixxXmlUtil parserAdapter: SixxVwXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self
		should: [(result at: 1)
				= 100].
	self
		should: [(result at: 2)
				= 'abcde'].
	self
		should: [(result at: 3)
				= #(10 20 )].
	self
		should: [(result at: 4)
				== result]]
		ensure: [SixxXmlUtil parserAdapter: oldParser]! !

!SixxXmlParserTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 15:00'!
testParseXmlWithSixxYaxoXmlParserAdapter
	| sixxString result oldParser |
	self class environment
		at: #XMLDOMParser
		ifAbsent: [^ self].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	[SixxXmlUtil parserAdapter: SixxYaxoXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self
		should: [(result at: 1)
				= 100].
	self
		should: [(result at: 2)
				= 'abcde'].
	self
		should: [(result at: 3)
				= #(10 20 )].
	self
		should: [(result at: 4)
				== result]]
		ensure: [SixxXmlUtil parserAdapter: oldParser]! !

SixxMockSuperClassForUnitTest initialize!
SixxMockClassForUnitTest initialize!